# $Revision: 1.1.2.30 $, $Date: 2008-02-19 23:26:32 $
#
# Conditional build:
%bcond_without	dist_kernel	# without distribution kernel
%bcond_without	up		# without up packages
%bcond_without	smp		# without smp packages
%bcond_without	kernel		# without kernel packages
%bcond_without	userspace	# don't build userspace programs
%bcond_with	verbose		# verbose build (V=1)

%if %{without kernel}
%undefine	with_dist_kernel
%endif
%if "%{_alt_kernel}" != "%{nil}"
%undefine	with_userspace
%endif

%define		_min_x11	6.7.0
#

%define		pname	X11-driver-nvidia-legacy2
Summary:	Linux Drivers for NVIDIA GeForce/Quadro Chips
Summary(pl):	Sterowniki do kart graficznych NVIDIA GeForce/Quadro
Name:		%{pname}%{_alt_kernel}
Version:	96.43.01
Release:	63
License:	nVidia Binary
Group:		X11
Source0:	http://download.nvidia.com/XFree86/Linux-x86/%{version}/NVIDIA-Linux-x86-%{version}-pkg1.run
# Source0-md5:	66f8b5e243aad22162e40d0f05f0bf1e
Source1:	http://download.nvidia.com/XFree86/Linux-x86_64/%{version}/NVIDIA-Linux-x86_64-%{version}-pkg1.run
# Source1-md5:	1cb134675bbdce8e172a0edc78618ed3
Source2:	%{pname}-settings.desktop
Source3:	%{pname}-xinitrc.sh
Patch0:		%{pname}-GL.patch
URL:		http://www.nvidia.com/object/unix.html
%if %{with kernel}
BuildRequires:	%{kgcc_package}
%{?with_dist_kernel:BuildRequires:	kernel%{_alt_kernel}-module-build >= 3:2.6.7}
BuildRequires:	rpmbuild(macros) >= 1.330
%endif
BuildRequires:	sed >= 4.0
BuildConflicts:	XFree86-nvidia
Requires:	X11-Xserver
Requires:	X11-libs >= %{_min_x11}
Requires:	X11-modules >= %{_min_x11}
Provides:	X11-OpenGL-core
Provides:	X11-OpenGL-libGL
Provides:	XFree86-OpenGL-core
Provides:	XFree86-OpenGL-libGL
Obsoletes:	Mesa
Obsoletes:	Mesa-libGL
Obsoletes:	X11-OpenGL-core
Obsoletes:	X11-OpenGL-libGL
Obsoletes:	XFree86-OpenGL-core
Obsoletes:	XFree86-OpenGL-libGL
Obsoletes:	XFree86-driver-nvidia
Obsoletes:	XFree86-nvidia
Conflicts:	XFree86-OpenGL-devel <= 4.2.0-3
ExclusiveArch:	%{ix86} %{x8664}
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_noautoreqdep	libGL.so.1 libGLcore.so.1
%define		_prefix		/usr/X11R6
%ifarch %{x8664}
%define		_libdir32	%{_prefix}/lib
%endif

%description
This driver set adds improved 2D functionality to the Xorg X server as
well as high performance OpenGL acceleration, AGP support, support for
most flat panels, and 2D multiple monitor support. Supported hardware:
modern NVIDIA GeForce (from GeForce2 MX) and Quadro (Quadro4 and up)
based graphics accelerators.

The older graphics chips are unsupported:
- NV1 and RIVA 128/128ZX chips are supported in the base Xorg install
  (nv driver)
- TNT/TNT2/GeForce 256/GeForce2 Ultra/Quadro2 are suported by -legacy
  drivers.

%description -l pl
Usprawnione sterowniki dla kart graficznych NVIDIA do serwera Xorg,
dajce wysokowydajn akceleracj OpenGL, obsug AGP i wielu monitorw
2D. Obsuguj w miar nowe karty NVIDIA GeForce (od wersji GeForce2
MX) oraz Quadro (od wersji Quadro4) do serwera Xorg/XFree86.

Starsze ukady graficzne NVIDIA nie s obsugiwane przez ten pakiet:
- NV1 i Riva 128/128ZX s obsugiwane przez sterownik nv z Xorg.
- TNT/TNT2/GeForce 256/GeForce2 Ultra/Quadro2 obsugiwane s przez
  sterownik NVIDIA w wersji -legacy.

%package devel
Summary:	OpenGL for X11R6 development (only gl?.h)
Summary(pl):	Pliki nagwkowe OpenGL dla systemu X11R6 (tylko gl?.h)
Group:		X11/Development/Libraries
Requires:	%{pname} = %{version}-%{release}
Provides:	OpenGL-devel-base
Obsoletes:	OpenGL-devel-base
Obsoletes:	XFree86-driver-nvidia-devel
Conflicts:	XFree86-OpenGL-devel < 4.3.99.902-0.3

%description devel
Base headers (only gl?.h) for OpenGL for X11R6 for nvidia drivers.

%description devel -l pl
Podstawowe pliki nagwkowe (tylko gl?.h) OpenGL dla systemu X11R6 dla
sterownikw nvidii.

%package progs
Summary:	Tools for advanced control of nVidia graphic cards
Summary(pl):	Narzdzia do zarzdzania kartami graficznymi nVidia
Group:		Applications/System
Requires:	%{pname} = %{version}-%{release}
Obsoletes:	XFree86-driver-nvidia-progs

%description progs
Tools for advanced control of nVidia graphic cards.

%description progs -l pl
Narzdzia do zarzdzania kartami graficznymi nVidia.

%package -n kernel%{_alt_kernel}-video-nvidia-legacy2
Summary:	nVidia kernel module for nVidia Architecture support
Summary(de):	Das nVidia-Kern-Modul fr die nVidia-Architektur-Untersttzung
Summary(pl):	Modu jdra dla obsugi kart graficznych nVidia
Group:		Base/Kernel
Requires(post,postun):	/sbin/depmod
Requires:	dev >= 2.7.7-10
%{?with_dist_kernel:Requires:	kernel%{_alt_kernel}(vermagic) = %{_kernel_ver}}
Provides:	X11-driver-nvidia-legacy2(kernel)
Obsoletes:	XFree86-nvidia-kernel

%description -n kernel%{_alt_kernel}-video-nvidia-legacy2
nVidia Architecture support for Linux kernel.

%description -n kernel%{_alt_kernel}-video-nvidia-legacy2 -l de
Die nVidia-Architektur-Untersttzung fr den Linux-Kern.

%description -n kernel%{_alt_kernel}-video-nvidia-legacy2 -l pl
Obsuga architektury nVidia dla jdra Linuksa. Pakiet wymagany przez
sterownik nVidii dla Xorg/XFree86.

%package -n kernel%{_alt_kernel}-smp-video-nvidia-legacy2
Summary:	nVidia kernel module for nVidia Architecture support
Summary(de):	Das nVidia-Kern-Modul fr die nVidia-Architektur-Untersttzung
Summary(pl):	Modu jdra dla obsugi kart graficznych nVidia
Group:		Base/Kernel
Requires(post,postun):	/sbin/depmod
Requires:	dev >= 2.7.7-10
%{?with_dist_kernel:Requires:	kernel%{_alt_kernel}-smp(vermagic) = %{_kernel_ver}}
Provides:	X11-driver-nvidia-legacy2(kernel)
Obsoletes:	XFree86-nvidia-kernel

%description -n kernel%{_alt_kernel}-smp-video-nvidia-legacy2
nVidia Architecture support for Linux kernel SMP.

%description -n kernel%{_alt_kernel}-smp-video-nvidia-legacy2 -l de
Die nVidia-Architektur-Untersttzung fr den Linux-Kern SMP.

%description -n kernel%{_alt_kernel}-smp-video-nvidia-legacy2 -l pl
Obsuga architektury nVidia dla jdra Linuksa SMP. Pakiet wymagany
przez sterownik nVidii dla Xorg/XFree86.

%prep
cd %{_builddir}
rm -rf NVIDIA-Linux-x86*-%{version}-pkg*
%ifarch %{ix86}
/bin/sh %{SOURCE0} --extract-only
%setup -qDT -n NVIDIA-Linux-x86-%{version}-pkg1
%else
/bin/sh %{SOURCE1} --extract-only
%setup -qDT -n NVIDIA-Linux-x86_64-%{version}-pkg1
%endif
%patch0 -p1
sed -i 's:-Wpointer-arith::' usr/src/nv/Makefile.kbuild

%build
%if %{with kernel}
cd usr/src/nv/
ln -sf Makefile.kbuild Makefile
cat >> Makefile <<'EOF'

$(obj)/nv-kernel.o: $(src)/nv-kernel.o.bin
	cp $< $@
EOF
mv nv-kernel.o{,.bin}
%build_kernel_modules -m nvidia
%endif

%install
rm -rf $RPM_BUILD_ROOT

%if %{with userspace}
install -d $RPM_BUILD_ROOT%{_libdir}/modules/{drivers,extensions} \
	$RPM_BUILD_ROOT{/usr/include/GL,/usr/%{_lib}/tls,%{_bindir},%{_mandir}/man1} \
	$RPM_BUILD_ROOT{%{_pixmapsdir},%{_desktopdir},/etc/X11/xinit/xinitrc.d}

ln -sf $RPM_BUILD_ROOT%{_libdir} $RPM_BUILD_ROOT%{_prefix}/../lib

install usr/bin/nvidia-settings $RPM_BUILD_ROOT%{_bindir}
install usr/bin/nvidia-xconfig $RPM_BUILD_ROOT%{_bindir}
install usr/share/pixmaps/nvidia-settings.png $RPM_BUILD_ROOT%{_pixmapsdir}
install usr/share/man/man1/nvidia-[sx]* $RPM_BUILD_ROOT%{_mandir}/man1
install %{SOURCE2} $RPM_BUILD_ROOT%{_desktopdir}/nvidia-settings.desktop
install %{SOURCE3} $RPM_BUILD_ROOT/etc/X11/xinit/xinitrc.d/nvidia-settings.sh
install usr/lib/libnvidia-tls.so.%{version} $RPM_BUILD_ROOT/usr/%{_lib}
install usr/lib/tls/libnvidia-tls.so.%{version} $RPM_BUILD_ROOT/usr/%{_lib}/tls
install usr/lib/libGL{,core}.so.%{version} $RPM_BUILD_ROOT%{_libdir}
install usr/X11R6/lib/modules/extensions/libglx.so.%{version} \
	$RPM_BUILD_ROOT%{_libdir}/modules/extensions

install usr/X11R6/lib/modules/drivers/nvidia_drv.so $RPM_BUILD_ROOT%{_libdir}/modules/drivers
install usr/X11R6/lib/libXvMCNVIDIA.so.%{version} $RPM_BUILD_ROOT%{_libdir}
install usr/X11R6/lib/libXvMCNVIDIA.a $RPM_BUILD_ROOT%{_libdir}
install usr/include/GL/*.h	$RPM_BUILD_ROOT/usr/include/GL

ln -sf libGL.so.1 $RPM_BUILD_ROOT%{_libdir}/libGL.so
ln -sf libglx.so.%{version} $RPM_BUILD_ROOT%{_libdir}/modules/extensions/libglx.so
ln -sf libXvMCNVIDIA.so.%{version} $RPM_BUILD_ROOT%{_libdir}/libXvMCNVIDIA.so

# OpenGL ABI for Linux compatibility
ln -sf %{_libdir}/libGL.so.1 $RPM_BUILD_ROOT/usr/%{_lib}/libGL.so.1
ln -sf %{_libdir}/libGL.so $RPM_BUILD_ROOT/usr/%{_lib}/libGL.so
%endif

%if %{with kernel}
%install_kernel_modules -m usr/src/nv/nvidia -d misc
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/ldconfig
cat << EOF

 *******************************************************
 *                                                     *
 *  NOTE:                                              *
 *  You must install:                                  *
 *  kernel(24)(-smp)-video-nvidia-legacy2-%{version}     *
 *  for this driver to work                            *
 *                                                     *
 *******************************************************

EOF

%postun	-p /sbin/ldconfig

%post	-n kernel%{_alt_kernel}-video-nvidia-legacy2
%depmod %{_kernel_ver}

%postun	-n kernel%{_alt_kernel}-video-nvidia-legacy2
%depmod %{_kernel_ver}

%post	-n kernel%{_alt_kernel}-smp-video-nvidia-legacy2
%depmod %{_kernel_ver}smp

%postun	-n kernel%{_alt_kernel}-smp-video-nvidia-legacy2
%depmod %{_kernel_ver}smp

%if %{with userspace}
%files
%defattr(644,root,root,755)
%doc LICENSE
%doc usr/share/doc/{README.txt,NVIDIA_Changelog,XF86Config.sample}
%attr(755,root,root) %{_libdir}/libGL.so.*.*
%attr(755,root,root) %{_libdir}/libGL.so
%attr(755,root,root) %{_libdir}/libGLcore.so.*.*
%attr(755,root,root) %{_libdir}/libXvMCNVIDIA.so.*.*
%dir /usr/%{_lib}/tls
%attr(755,root,root) /usr/%{_lib}/libnvidia-tls.so.*.*.*
%attr(755,root,root) /usr/%{_lib}/tls/libnvidia-tls.so.*.*.*
%attr(755,root,root) /usr/%{_lib}/libGL.so.1
%attr(755,root,root) /usr/%{_lib}/libGL.so
%attr(755,root,root) %{_libdir}/modules/extensions/libglx.so*
%attr(755,root,root) %{_libdir}/modules/drivers/nvidia_drv.so
%endif

%if %{with kernel}
%if %{with up} || %{without dist_kernel}
%files -n kernel%{_alt_kernel}-video-nvidia-legacy2
%defattr(644,root,root,755)
/lib/modules/%{_kernel_ver}/misc/*.ko*
%endif

%if %{with smp} && %{with dist_kernel}
%files -n kernel%{_alt_kernel}-smp-video-nvidia-legacy2
%defattr(644,root,root,755)
/lib/modules/%{_kernel_ver}smp/misc/*.ko*
%endif
%endif

%if %{with userspace}
%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libXvMCNVIDIA.so
/usr/include/GL/*.h
%{_libdir}/libXvMCNVIDIA.a

%files progs
%defattr(644,root,root,755)
%doc usr/share/doc/nvidia-settings-user-guide.txt
%attr(755,root,root) %{_bindir}/nvidia-settings
%attr(755,root,root) %{_bindir}/nvidia-xconfig
%attr(755,root,root) /etc/X11/xinit/xinitrc.d/*.sh
%{_desktopdir}/*.desktop
%{_mandir}/man1/*
%{_pixmapsdir}/*
%endif

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: X11-driver-nvidia-legacy2.spec,v $
Revision 1.1.2.30  2008-02-19 23:26:32  glen
- release 63

Revision 1.1.2.29  2008-02-15 01:29:33  glen
- use kernel vermagic in deps

Revision 1.1.2.28  2008-02-12 11:01:11  glen
- release 61 (kernel-2.6.16.60-4)

Revision 1.1.2.27  2008-01-28 09:33:20  glen
- rel 60 (kernel-2.6.16.60-1)

Revision 1.1.2.26  2008-01-18 12:27:50  glen
- rel 59 (2.6.16.58-1)

Revision 1.1.2.25  2007-11-06 18:28:42  glen
- rel 58 (2.6.16.57-1)

Revision 1.1.2.24  2007/11/04 20:22:05  glen
- prefix src package with alt kernel if present

Revision 1.1.2.23  2007/11/01 08:27:24  adamg
- release 57 (rebuild against 2.6.16.56-1)

Revision 1.1.2.22  2007/10/22 20:41:53  glen
- disable userspace for alt kernel

Revision 1.1.2.21  2007/10/22 20:24:59  glen
- unify kernel macros

Revision 1.1.2.20  2007/10/22 19:48:29  glen
- allow build without up kernel

Revision 1.1.2.19  2007/10/22 09:06:03  hawk
- rel 56

Revision 1.1.2.18  2007/10/20 12:18:00  hawk
- package xconfig and man files

Revision 1.1.2.17  2007/10/20 12:07:19  hawk
- use new kernel module build macros

Revision 1.1.2.16  2007/10/20 11:59:09  hawk
- src.rpm contents shouldn't be arch or bcond dependent
- updated URL, removed obsolete conftest.patch, cleanup

Revision 1.1.2.15  2007/10/18 12:35:21  hawk
- updated to 96.43.01

Revision 1.1.2.14  2007/10/15 08:26:44  glen
- rel 55 (kernel 2.6.16.55)

Revision 1.1.2.13  2007/10/15 08:21:38  glen
- rel drbd.spec (2.6.16.55)

Revision 1.1.2.12  2007/10/01 21:25:45  glen
- rel 54

Revision 1.1.2.11  2007/09/30 22:17:50  adamg
- release 53.1 (rebuild against 2.6.16.53-2)

Revision 1.1.2.10  2007/09/05 19:30:12  glen
- rel 53 (kernel 2.6.16.53)

Revision 1.1.2.9  2007/06/16 19:36:12  hawk
- updated to 1.0.9639

Revision 1.1.2.8  2007/06/04 08:09:08  glen
- rel 52 (2.6.16.52)

Revision 1.1.2.7  2007/05/11 06:38:50  glen
- rel 51 (2.6.16.51)

Revision 1.1.2.6  2007/05/08 12:10:09  glen
- rel 50 (kernel 2.6.16.50)

Revision 1.1.2.5  2007/04/25 22:13:24  glen
- rel 4 (kernel 2.6.16.49)

Revision 1.1.2.4  2007/04/08 23:58:55  shadzik
- rel 3
- STBR

Revision 1.1.2.3  2007/04/08 23:58:18  shadzik
- O: Mesa-libGL

Revision 1.1.2.2  2007/04/08 23:44:14  hawk
- fixed kernel packages names, release 2

Revision 1.1.2.1  2007/03/28 14:48:32  hawk
- revived nvidia 96xx drivers as legacy2 for Ac

